//MD
//2021
	
#define Uart_Port_Sel   0x00
// ========================================================
#include <stdio.h>
#include <intrins.h>
#include "N79E81x.h"
//#include "Typedef.h"
//#include "Define.h"
//#include "Common.h"
//#include "Version.h"

#include "WDT.h"
#include "MD1239_MCU_Define.h"
#include "function_arg.h"
#include "SPI.c"
#include "MD1239.c"



void InitPort(void);
void Init_MCU_Reg(void);
void Init_MCU_RAM(void);
void timer1_init(void);
void timer2_init(void);
void Uart_init(void);
void Init_WDT(void);
void ISR_timer(void);





void timer2_init(void);
void Init_PWM(void);  
void Init_ADC(void);
 

void Timer0_ISR(void); 
void INT0_ISR(void);
void INT1_ISR(void);
void Timer1_ISR(void);
void Timer2_ISR(void);
//void I2C_ISR(void);
void KBI_ISR(void);
//void BOD_ISR(void);
//void SPI_ISR(void);
void WDT_ISR(void);
void ADC_ISR(void);
//void Capture_ISR(void);
//void PWM_Brake_ISR(void);
void Stop_PWM(void);
//void LowBat_Detect(void);
//void delay_x5ms(void);
void key_scan(void);

//void InitialUART0_Timer1(u32 u32Baudrate);
//void Send_Data_To_PC (u8 c);
		  
//void mo_run(void);
//void BPS_Delay(void);
//void SendOut(unsigned char tx_buf);

//void Charg_Detect(void);

/**********************************************************
**Name:    
**Function: 
**Input:    none
**Output:   none
**********************************************************/

//void Enabled_Brake_Function(void)
//{
//    PWMCON1 = 0x30;                    // PWM is running. PWM will be stopped when P0.2 is low level.
//}

    
/**********************************************************
**Name:    
**Function: 
**Input:    none
**Output:   none
**********************************************************/
//-----------------------------------------------------------------------------------------------------------
//void Enable_ADC_Interrupt(void)
//{
//    EADC = 1;
//    EA = 1;
//}
/**********************************************************/

//==========================================
//
//==========================================
void mcu_sleep(void)
{
  //P0:	P0.6,0.4,0 OUT; P0.7,0.5,0.3,0.2,0.1 input (׼˫ģʽʱΪ룬дʱΪ
   //PxM1 PxM2=00 ׼˫ģʽ
   //         =01 ģʽ
   //         =10 ģʽ
   //         =11 ©ģʽ
	P0M1=0X00;//0x80;	//10000000
	P0M2=0X00;//0X01;	//00000001

	P1M1=0X00;//0X02;	//00000010
	P1M2=0X00;//0X1D;	//00011101
	
	P3M1&=0XFC;	
	P3M2&=0XFC;
	//P3M2|=0x03;    //P31,P30 OPEN drain;	

	
	    gb_en_rx_flag=0;
            GLED=1;
            RLED=1;
   	    EA=0;
	    ET0 = 0;  
	    ET2 = 0;
	    WDTF=0;
	    EWDI= 0;	
	    
	    KBLS0 =0X00;//P03 as DC CHARGE and edge changed
	    KBLS1 =0X08;//KBLS1.3 : KBLS0.3=10 edge changed
	    		//P05 as key input(falling)
	                //KBLS1.5,KBLS0.5=00 Falling edge for key input

            KBIF = 0x00;//Clear KBF
	    KBIE = 0X28;//KB3(charge),KB5(KEY) EN INT  
	    
	   // if(gb_auto_sleep_flag==1)
//		    EWDI=1;
//	    else{
	      TA = 0xAA;
              TA = 0x55;
	      WDCON0=0x00; //dis WDT
//	    }
	    ADCCON1=0X00;//DISABLE adc
	    
	    EKB = 1;    //Enable KBI Interrupt
            EA  = 1;    //Enable EA
	    PCON |=0x02;//power down
	   _nop_();
	   _nop_();
	   _nop_();
	    GLED=0;
	    Delayn(5);
   }
     	



/*==================================================================*/
void main(void)
{ 
   BZ_OUT=0;
   Stop_PWM();

   Delayn(200);

  Init_MCU_Reg();                                  
  InitPort();                                       
  Init_MCU_RAM();
  timer0_init();
  timer2_init();
  Init_PWM(); 
  Init_WDT();  
  Init_ADC();
  gb_FreqBuf_Addr=2;
  gb_RateBuf_Addr=1;
  MD1239_Config();
 
  GLED=0;
  RLED=0;
  Delayn(200);
   GLED=1;
   RLED=1;
   Delayn(200);
   GLED=0;
   RLED=0;
  Delayn(200);
   
   
 
   gb_rf_windows=c_rfwindows;
   gb_rf_off_time=c_rf_off_time;
   gb_led_on_time=10;//2;
   gb_led_duration_cnt=2;//5; 
   gb_auto_sleep_cnt=c_sleep_time;//1800;


   gb_unit_on_flag=0x01;
   
 
   gb_bz_en_flag=0x0;
   gb_lt_en_flag=0x0;
  
   gb_key_press_flag=0x0;
   gb_key_hold_flag=0x0;
   gb_LED_light_flag=0;

   //gb_en_rx_flag=0X01;

  gb_en_tx_flag=1;
	    gb_en_rx_flag=0;
		 gb_rf_off_time=0;
	gb_auto_tx_cnt=c_auto_tx_time;	 	
 
  MD1239_Sleep();
  while(1)
  { 
   	 
   gb_en_rx_flag=0;
    
   MD1239_Sleep();

   mcu_sleep();


  }
}
/**********************************************************
**Name:     InitPort
**Function: Initialize Port
**Input:    none
**Output:   none
#define BZ_OUT		P00
#define SP0             P01
#define SP1             P02
#define SP2             P03
#define BANK_SEL_VR     P04
#define KEY_IN		P05  
#define nRESET		P06
#define DIO0		P07

#define SCK		P10
#define MISO		P11
#define MOSI		P12
#define LNA_EN		P13
#define NSS             P14  		        	
#define sim_uart_tx     P16  
#define SP3             P17
#define GLED		P30
#define RLED		P31
**********************************************************/
void InitPort(void)
{
   //P0:	P0.6,0.4,0 OUT; P0.7,0.5,0.3,0.2,0.1 input (׼˫ģʽʱΪ룬дʱΪ
   //PxM1 PxM2=00 ׼˫ģʽ
   //         =01 ģʽ
   //         =10 ģʽ
   //         =11 ©ģʽ
	P0M1=0X00;//0x80;	//10000000
	P0M2=0X00;//0X01;	//00000001

	P1M1=0X00;//0X02;	//00000010
	P1M2=0X00;//0X1D;	//00011101
	
	P3M1&=0XFC;	
	P3M2&=0XFC;
	//P3M2|=0x03;    //P31,P30 OPEN drain;	

 
}
/**********************************************************

***********************************************************/
void Init_MCU_RAM(void)
{
	gw_RF_SentInterval=100;		//100*50ms
	
	gb_rf_windows=8;
	gb_rf_off_time=16;
	gb_en_rx_flag=1;
	
	
	
	
}	
/**********************************************************
ƣInit_MCU_Reg
ܣ
**********************************************************/
void Init_MCU_Reg(void)
{
	//DIVM=0X01;			//5.5296MHZ	fsys=fosc/(2(DIVM+1))	@22.1184MHZ
       KBLS1 =0X00;						//KBLS1.5,KBLS0.5=00 Falling edge for key input
       KBIF = 0x00;                        // Clear KBF
 	   KBIE = 0X20;						//KB5(KEY) EN INT  
	   EKB = 1;     					  // Enable KBI Interrupt
       EA  = 1;                            // Enable EA



//adc




}

/**********************************************************
**Name:     Init_PWM
**Function: pwm Initialization
**Input:    none
**Output:   none
**********************************************************/
void Init_PWM(void)
{
     // BZ_OUT=1;
	//PWMP=;
//    PWMPH = HIBYTE(PWM_shadow);         // PWM Period
//    PWMPL = LOBYTE(PWM_shadow);
    //PWMCON0 = 0xD0;                     // Enable PWM and select auto reload mode
	PWMCON0 = 0x00;//
    PWMCON1 = 0x00;//
    PWMCON2 = 0x00;//
        _nop_ ();      // NOP
		BZ_OUT=0;

}

void Init_WDT(void)
{
    
    EA = 0;
    TA = 0xAA;
    TA = 0x55;
	WDCON0|=0X40;						// CLEAR WDT TIMER COUNTER
    TA = 0xAA;
    TA = 0x55;
	WDCON0|=0X80;						//ENABLE WDT TO RUN

	TA=0XAA;
	TA=0X55;
	WDCON0|=0x06;//0x07;//0X06;						//SELECT WDT DIV (INTERVAL LENGTH)

	TA=0XAA;
	TA=0X55;
	WDCON1&=0XFE;						//Disable watchdog Timer Reset
	EWDI=1;								//Enable Watchdong Timer interrupt

	TA=0XAA;
	TA=0X55;
	WIDPD=1;
	EA=1;

 }

 /**********************************************************
**Name:     Init_ADC
**Function: ADC Initialization
**Input:    none
**Output:   none
**********************************************************/
void Init_ADC(void)
{
 	P0DIDS|=0X04;		//disable P0.2 digital function
	P0M1|=0X04;			//ADC1(P0.2) is input only mode
	P0M2&=0XFB;
	ADCI=0;
	ADCS=0;
	AADR2=0;   			//ADC1(P0.2) as ADC channel fuction
	AADR1=0;
	AADR0=1;
	ADCEX=0;			//DIS EXT P1.4 trigger adc start
	ADCCON1&=0XFD;		//fsys/4 clock is ADC clock
	EADC=1;
	EA=1;
	ADCCON1 |=0X80;		//enable ADC function
 }
/**********************************************************
**Name:     bz_output
**Function: buzzer output 1khz
**Input:    none
**Output:   none
**********************************************************/
void 	bz_output(void)
{	    
		//P1M2=0X80;
		//P1M1=0X00;						//P1.7 Driver pull-plug mode
	  BZ_OUT=1;
		
	  PWMCON0=0X10;						//STOP PWM AND CLEAR PWM 
	  PWMCON2=0X0C;						//prescale:FP1,FP0=11, Fpwm=fsys/16 
	  PWM_shadow=276;//default
          
          PWMPH = (PWM_shadow>>8)&0XFF;         // PWM Period
          PWMPL = PWM_shadow&0XFF;
	   
	  PWM_shadow=138;//250;//345;		//50%duty (PWMP=690)

	  PWM2H = (PWM_shadow>>8)&0XFF;         
	  PWM2L = PWM_shadow&0XFF; 
	  PWMCON0 = 0xD0;
}

/**********************************************************
**Name:     key_tone
**Function: buzzer output 1khz and timer ms
**Input:    none
**Output:   none
**********************************************************/
void key_tone(void)
{
	bz_output();
	Delayn(200);
	Delayn(200);
	
	Stop_PWM();	//stop pwm	
}
/**********************************************************
**Name:     timer0_init
**Function: timer0 Initialization
**Input:    none
**Output:   none
**********************************************************/
void timer0_init(void)
{
 TMOD &= 0xF0;                   // Timer 0 mode 1 with hardware gate
    TMOD |= 0x01;                   // GATE0=0; C/T0#=0; M10=0; M00=1;
	//10ms
    //TH0 =(65536-10000)/256;	//TH0_Value;                // Initial values
    //TL0 = (65536-10000)%256;	//TL0_Value;

	//100us
	TH0 =(65536-100)/256;	//TH0_Value;                // Initial values
    TL0 = (65536-100)%256;	//TL0_Value;

    ET0 = 1;                        // Enable timer0 interrupt
    EA = 1;                         // Enable interrupts
    TR0 = 1;                        // Timer0 run
}


 

/**********************************************************
**Name:     timer2_init
**Function: timer2 Initialization
**Input:    none
**Output:   none
timer2 is 16bit count up timer
;fsys=11.0592mhz
;scale:1/32
;Td=32/11.0592=2.893519us
20000/Td=1AFF->6911 (dec)
**********************************************************/
void timer2_init(void)
{
    T2MOD = 0xb0;                       //LDEN=1,T2DIV=011. Enabled auto-reload and timer2 clock divider is 1/32
    TR2=0;
	CP_RL2=0;							//TIMER MODE
    TH2 =(65536-6911)/256;                         // Initial values
    TL2 =(65536-6911)%256;
    RCOMP2L = TL2 ;                      // Reload values initialize
    RCOMP2H = TH2 ;

	TR2=1;								//timer2 running
	ET2=1;								//enable timer2 interrupt
    EA = 1;                             // Enable interrupts
    
}



//-----------------------------------------------------------------------------------------------------------
void Timer0_ISR(void) interrupt 1   // Vector @  0x0B
{
//	//1.09us
    TF0 = 0;                        // Reset timer0 interrupt flag (already done by hardware)

}
//-----------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------
void INT0_ISR(void) interrupt 0          // Vector @  0x03
{
    //P0 = 0xFF-1;
    IE0=0;
}

//-----------------------------------------------------------------------------------------------------------
void INT1_ISR(void) interrupt 2          // Vector @  0x13
{
    //P0 = 0xFF-3;
    IE1=0;
}
//-----------------------------------------------------------------------------------------------------------
void Timer1_ISR(void) interrupt 3        // Vector @  0x1B
{
    //P0 = 0xFF-4;
    TF1=0;
    
       
   
    
    
    
}

//-----------------------------------------------------------------------------------------------------------
void Timer2_ISR(void) interrupt 5        // Vector @  0x2B
{								   		//about 20ms
    
    TF2=0;
//	RLED=~RLED;		  //test 
	

 

   if(gb_timer_over!=0)
	{
	 gb_timer_over--;

	  }
     
       if((gb_key_press_flag==0x00)&&(gb_led_on_time!=0x0))
 	      {
 	        gb_led_on_time--;
	        if(gb_led_on_time==0x0)
	       {  GLED=1;					//OFF		  
			 RLED=1;
			 gb_LED_light_flag=0;
			 }
	      }
	      
     if(gb_key_debounce_time!=0)
	{
	 gb_key_debounce_time--;
	 if(gb_key_debounce_time==0)
	    gb_key_debounce_flag=1;
	  }

	    
  

		    
    if(gb_rf_windows!=0)
	{
	 gb_rf_windows--;
	 if(gb_rf_windows==0)
	    gb_en_rx_flag=0;
	  }
    
    if(gb_rf_off_time!=0)
	{
	   gb_rf_off_time--;
	   if(gb_rf_off_time==0)	  
          { gb_rf_windows=c_rfwindows; //3;
            gb_rf_off_time=c_rf_off_time;//6;
		    gb_en_rx_flag=1;}			
     }
 
 
	

	 if(gb_key_hold_cnt!=0)	// x50ms*80=4s
	 	{gb_key_hold_cnt--;
	 		if(gb_key_hold_cnt==0)
	 			gb_key_hold_flag=0x01;
	 	} 



	

	   //2S
	   //0.5s
	   gb_sec_cnt++;
	 if(gb_sec_cnt>25) //0.5s //100)	//two second
	 {	gb_sec_cnt=0;
	 	
           if(gb_auto_tx_cnt!=0)
   {
     gb_auto_tx_cnt--;
	 if(gb_auto_tx_cnt==0)
	    {
		  gb_en_tx_flag=1;
		  gb_en_rx_flag=0;
		  gb_rf_off_time=0;
		  }
	}	
			

		}

   
}
//-----------------------------------------------------------------------------------------------------------
void I2C_ISR(void) interrupt 6           // Vector @  0x33
{
    P0 = 0xFF-7;
    SI=0;
}
//-----------------------------------------------------------------------------------------------------------
void KBI_ISR(void) interrupt 7           // Vector @  0x3B
{
    //P0 = 0xFF-8;
    //clr_KBIF0;
    KBIF = 0x00;                        // Clear KBF flag
    gb_KBI_int_flag=1;
	
}
//-----------------------------------------------------------------------------------------------------------
void BOD_ISR(void) interrupt 8           // Vector @  0x43
{
    //P0 = 0xFF-9;
//    BOF=0;
}
//-----------------------------------------------------------------------------------------------------------
void SPI_ISR(void) interrupt 9           // Vector @  0x4B
{
    //P0 = 0xFF-10;
//    clr_SPIF;
}
//-----------------------------------------------------------------------------------------------------------
//10K RC->100US  +/-50%
void WDT_ISR(void) interrupt 10          // Vector @  0x53
{							   			// 860ms
    //P0 = 0xFF-11;
	//for LED flashing
	//for learning mode timer
	EA=0;
	TA=0XAA;
	TA=0X55;
	WDCON0|=0X40;				//CLEAR WATCHDOG TIMER COUNTER
	EA=1;

	EA=0;
	TA=0XAA;
	TA=0X55;
	WDCON0&=0XDF;			//clear watchdog timer interrupt;
	EA=1;
	 // GLED=~GLED;
	

	      if(gb_led_duration_cnt!=0)
	        {
			  gb_led_duration_cnt--;

	          if(gb_led_duration_cnt==0x0)
	          {
	          gb_led_on_time=10;//8;//4;
	          gb_led_duration_cnt=2;//3;
			  //gb_lb_test_flag=1;
			  if(gb_LED_light_flag!=1)
			  {
			  RLED=0;
			  //GLED=0;
			   }
			  }
	        }
			
			
		
       			
       
}
//-----------------------------------------------------------------------------------------------------------
void ADC_ISR(void) interrupt 11          // Vector @  0x5B
{
   // P0 = 0xFF-12;
    ADCI=0;


}
//-----------------------------------------------------------------------------------------------------------
void Capture_ISR(void) interrupt 12      // Vector @  0x63
{
    //P0 = 0xFF-13;
//    CAPF0=0;
}
//-----------------------------------------------------------------------------------------------------------
void PWM_Brake_ISR(void) interrupt 14    // Vector @  0x73
{
    //P0 = 0xFF-14;
//    BKF=0;
}
//-----------------------------------------------------------------------------------------------------------


void Stop_PWM(void)
{
    PWMCON0 = 0x00;//
    PWMCON1 = 0x00;//
    PWMCON2 = 0x00;//
        _nop_ ();      // NOP
		BZ_OUT=0;
		//AC_OUT=0;
		//MO_OUT=0;
    
}


/**************************************************************
Name: key_scan
Function: press the key operation:on/off, learning mode 
	;test mode(for RF sensitivity testing)	
key scan and process
***************************************************************/
void key_scan(void)
{
    if (key_in==0)
	    {

		 if(gb_key_debounce_flag==1)
		   {
		     //gb_key_debounce_flag=0; 	//clr after used
		     if(gb_key_name==c_none_key)
			   {
			    //new press
			    gb_key_name=c_onoff_key;
				gb_key_hold_cnt=2;//80;//0.8s  25;  	//0.5s for confirm turn off
				gb_key_hold_flag=0;
				gb_key_press_flag=1;
				gb_KBI_int_flag=0;
				gb_auto_sleep_flag=0;
			    gb_auto_sleep_cnt=c_sleep_time;//1800;

				SendOut(gb_key_name);
				SendOut(0x01);
				 	gb_en_tx_flag=1;
	      gb_en_rx_flag=0;
		   gb_rf_off_time=0;

				}		
		    }
		 }
	

       else if(key_in!=0)				
		//key release
	   {
	    gb_key_debounce_time=4;		//60~80ms
	    gb_key_debounce_flag=0;
		if(gb_key_press_flag!=0)
		{
		RLED=1;GLED=1;
		gb_key_hold_cnt=0;
		gb_key_hold_flag=0;
		gb_key_name=c_none_key;
		gb_key_press_flag=0;
	
			 	
		} 
	  } 
  
}
/**********************************************************
**Name:    
**Function: 
**Input:    none
**Output:   none
**********************************************************/	




/**********************************************************
**Name:    
**Function: 
**Input:    none
**Output:   none
**********************************************************/
 void Delayn(unsigned char tt)
{
	unsigned char i;
	unsigned char j;
	
	for(i=tt; i>0; i--)   //
	{
		for(j=250;j>0;j--)
		{
		 _nop_ ();
		 _nop_ ();
		 _nop_ ();
		 _nop_ ();
		_nop_ ();
		 _nop_ ();
		 _nop_ ();
		 _nop_ ();
	 }	
   }	 
}   
//********************************************************************************/
//#define  UART_SEND_Pin GPIO4        //GPIO4=TXD
//********************************************************************************
void BPS_Delay(void){

       u8 i;
	   for(i=0;i<20;i++)
	   {
	   ;
	   }

}
//*********************************************************************************
//һ			19200
//*********************************************************************************
void SendOut(unsigned char tx_buf)
{
        unsigned char i,Dat;           
                i=8;                                                  //19200 8.n 1        P d8 S
                sim_uart_tx=0;                        //ʼλ
                BPS_Delay();
                Dat=tx_buf;
                while(i--){
                        sim_uart_tx=(bit)(Dat & 0x01);
                        Dat>>=1;        
                        BPS_Delay();
                }
                sim_uart_tx=1;
                BPS_Delay();        

}




//===============================



/*eof*/ 